/* StatusIcon.c generated by valac 0.10.0, the Vala compiler
 * generated from StatusIcon.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    © 2009–2010 Michael Terry <mike@mterry.name>

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <common.h>
#include <glib/gi18n-lib.h>
#include <whacks.h>
#include <libnotify/notify.h>


#define TYPE_STATUS_ICON (status_icon_get_type ())
#define STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATUS_ICON, StatusIcon))
#define STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATUS_ICON, StatusIconClass))
#define IS_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATUS_ICON))
#define IS_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATUS_ICON))
#define STATUS_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATUS_ICON, StatusIconClass))

typedef struct _StatusIcon StatusIcon;
typedef struct _StatusIconClass StatusIconClass;
typedef struct _StatusIconPrivate StatusIconPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SHELL_STATUS_ICON (shell_status_icon_get_type ())
#define SHELL_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SHELL_STATUS_ICON, ShellStatusIcon))
#define SHELL_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SHELL_STATUS_ICON, ShellStatusIconClass))
#define IS_SHELL_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SHELL_STATUS_ICON))
#define IS_SHELL_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SHELL_STATUS_ICON))
#define SHELL_STATUS_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SHELL_STATUS_ICON, ShellStatusIconClass))

typedef struct _ShellStatusIcon ShellStatusIcon;
typedef struct _ShellStatusIconClass ShellStatusIconClass;

#define TYPE_INDICATOR_STATUS_ICON (indicator_status_icon_get_type ())
#define INDICATOR_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDICATOR_STATUS_ICON, IndicatorStatusIcon))
#define INDICATOR_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INDICATOR_STATUS_ICON, IndicatorStatusIconClass))
#define IS_INDICATOR_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDICATOR_STATUS_ICON))
#define IS_INDICATOR_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INDICATOR_STATUS_ICON))
#define INDICATOR_STATUS_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INDICATOR_STATUS_ICON, IndicatorStatusIconClass))

typedef struct _IndicatorStatusIcon IndicatorStatusIcon;
typedef struct _IndicatorStatusIconClass IndicatorStatusIconClass;

#define TYPE_LEGACY_STATUS_ICON (legacy_status_icon_get_type ())
#define LEGACY_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LEGACY_STATUS_ICON, LegacyStatusIcon))
#define LEGACY_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LEGACY_STATUS_ICON, LegacyStatusIconClass))
#define IS_LEGACY_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LEGACY_STATUS_ICON))
#define IS_LEGACY_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LEGACY_STATUS_ICON))
#define LEGACY_STATUS_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LEGACY_STATUS_ICON, LegacyStatusIconClass))

typedef struct _LegacyStatusIcon LegacyStatusIcon;
typedef struct _LegacyStatusIconClass LegacyStatusIconClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _IndicatorStatusIconPrivate IndicatorStatusIconPrivate;
typedef struct _ShellStatusIconPrivate ShellStatusIconPrivate;
typedef struct _LegacyStatusIconPrivate LegacyStatusIconPrivate;

struct _StatusIcon {
	GObject parent_instance;
	StatusIconPrivate * priv;
	gboolean is_valid;
	char* action;
	double progress;
	char* later_label;
	char* skip_label;
	GtkMenu* menu;
};

struct _StatusIconClass {
	GObjectClass parent_class;
	void (*update_progress) (StatusIcon* self);
};

struct _StatusIconPrivate {
	GtkWindow* _window;
	DejaDupOperation* _op;
	gboolean _automatic;
};

struct _IndicatorStatusIcon {
	StatusIcon parent_instance;
	IndicatorStatusIconPrivate * priv;
};

struct _IndicatorStatusIconClass {
	StatusIconClass parent_class;
};

struct _IndicatorStatusIconPrivate {
	GObject* indicator;
};

struct _ShellStatusIcon {
	StatusIcon parent_instance;
	ShellStatusIconPrivate * priv;
};

struct _ShellStatusIconClass {
	StatusIconClass parent_class;
};

struct _ShellStatusIconPrivate {
	gboolean persistence;
	gboolean actions;
};

struct _LegacyStatusIcon {
	StatusIcon parent_instance;
	LegacyStatusIconPrivate * priv;
};

struct _LegacyStatusIconClass {
	StatusIconClass parent_class;
};

struct _LegacyStatusIconPrivate {
	GtkStatusIcon* icon;
};


static gpointer status_icon_parent_class = NULL;
static gpointer indicator_status_icon_parent_class = NULL;
static gpointer shell_status_icon_parent_class = NULL;
static gpointer legacy_status_icon_parent_class = NULL;

GType status_icon_get_type (void) G_GNUC_CONST;
#define STATUS_ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_STATUS_ICON, StatusIconPrivate))
enum  {
	STATUS_ICON_DUMMY_PROPERTY,
	STATUS_ICON_WINDOW,
	STATUS_ICON_OP,
	STATUS_ICON_AUTOMATIC
};
StatusIcon* status_icon_create (GtkWindow* window, DejaDupOperation* op, gboolean automatic);
ShellStatusIcon* shell_status_icon_new (GtkWindow* window, DejaDupOperation* op, gboolean automatic);
ShellStatusIcon* shell_status_icon_construct (GType object_type, GtkWindow* window, DejaDupOperation* op, gboolean automatic);
GType shell_status_icon_get_type (void) G_GNUC_CONST;
IndicatorStatusIcon* indicator_status_icon_new (GtkWindow* window, DejaDupOperation* op, gboolean automatic);
IndicatorStatusIcon* indicator_status_icon_construct (GType object_type, GtkWindow* window, DejaDupOperation* op, gboolean automatic);
GType indicator_status_icon_get_type (void) G_GNUC_CONST;
LegacyStatusIcon* legacy_status_icon_new (GtkWindow* window, DejaDupOperation* op, gboolean automatic);
LegacyStatusIcon* legacy_status_icon_construct (GType object_type, GtkWindow* window, DejaDupOperation* op, gboolean automatic);
GType legacy_status_icon_get_type (void) G_GNUC_CONST;
static void status_icon_set_action_desc (StatusIcon* self, DejaDupOperation* op, const char* action);
void status_icon_update_progress (StatusIcon* self);
static void status_icon_note_progress (StatusIcon* self, DejaDupOperation* op, double progress);
static void status_icon_real_update_progress (StatusIcon* self);
void status_icon_later (StatusIcon* self);
DejaDupOperation* status_icon_get_op (StatusIcon* self);
void status_icon_skip (StatusIcon* self);
GtkMenu* status_icon_ensure_menu (StatusIcon* self);
static void _lambda2_ (GtkMenuItem* i, StatusIcon* self);
static void __lambda2__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void _lambda3_ (GtkMenuItem* i, StatusIcon* self);
static void __lambda3__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
gboolean status_icon_get_automatic (StatusIcon* self);
static void _lambda4_ (GtkMenuItem* i, StatusIcon* self);
static void __lambda4__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
StatusIcon* status_icon_construct (GType object_type);
GtkWindow* status_icon_get_window (StatusIcon* self);
static void status_icon_set_window (StatusIcon* self, GtkWindow* value);
static void status_icon_set_op (StatusIcon* self, DejaDupOperation* value);
static void status_icon_set_automatic (StatusIcon* self, gboolean value);
static void _status_icon_set_action_desc_deja_dup_operation_action_desc_changed (DejaDupOperation* _sender, const char* action, gpointer self);
static void _status_icon_note_progress_deja_dup_operation_progress (DejaDupOperation* _sender, double percent, gpointer self);
static GObject * status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void status_icon_finalize (GObject* obj);
static void status_icon_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void status_icon_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define INDICATOR_STATUS_ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_INDICATOR_STATUS_ICON, IndicatorStatusIconPrivate))
enum  {
	INDICATOR_STATUS_ICON_DUMMY_PROPERTY
};
static GObject * indicator_status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void indicator_status_icon_finalize (GObject* obj);
#define SHELL_STATUS_ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SHELL_STATUS_ICON, ShellStatusIconPrivate))
enum  {
	SHELL_STATUS_ICON_DUMMY_PROPERTY
};
static void _lambda0_ (ShellStatusIcon* self);
static void __lambda0__notify_action_callback (NotifyNotification* notification, const char* action, gpointer self);
static void _lambda1_ (ShellStatusIcon* self);
static void __lambda1__notify_action_callback (NotifyNotification* notification, const char* action, gpointer self);
static GObject * shell_status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void shell_status_icon_finalize (GObject* obj);
#define LEGACY_STATUS_ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LEGACY_STATUS_ICON, LegacyStatusIconPrivate))
enum  {
	LEGACY_STATUS_ICON_DUMMY_PROPERTY
};
static void legacy_status_icon_real_update_progress (StatusIcon* base);
static void legacy_status_icon_show_menu (LegacyStatusIcon* self, GtkStatusIcon* status_icon, guint button, guint activate_time);
static void _gtk_status_icon_position_menu_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self);
static void _legacy_status_icon_show_menu_gtk_status_icon_popup_menu (GtkStatusIcon* _sender, guint button, guint activate_time, gpointer self);
static void _lambda5_ (GtkStatusIcon* s, LegacyStatusIcon* self);
static void __lambda5__gtk_status_icon_activate (GtkStatusIcon* _sender, gpointer self);
static GObject * legacy_status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void legacy_status_icon_finalize (GObject* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);



StatusIcon* status_icon_create (GtkWindow* window, DejaDupOperation* op, gboolean automatic) {
	StatusIcon* result = NULL;
	StatusIcon* instance;
	StatusIcon* _tmp0_;
	g_return_val_if_fail (window != NULL, NULL);
	g_return_val_if_fail (op != NULL, NULL);
	instance = NULL;
	instance = (_tmp0_ = (StatusIcon*) shell_status_icon_new (window, op, automatic), _g_object_unref0 (instance), _tmp0_);
	if (!instance->is_valid) {
		StatusIcon* _tmp1_;
		instance = (_tmp1_ = (StatusIcon*) indicator_status_icon_new (window, op, automatic), _g_object_unref0 (instance), _tmp1_);
	}
	if (!instance->is_valid) {
		StatusIcon* _tmp2_;
		instance = (_tmp2_ = (StatusIcon*) legacy_status_icon_new (window, op, automatic), _g_object_unref0 (instance), _tmp2_);
	}
	result = instance;
	return result;
}


static void status_icon_set_action_desc (StatusIcon* self, DejaDupOperation* op, const char* action) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (op != NULL);
	g_return_if_fail (action != NULL);
	self->action = (_tmp0_ = g_strdup (action), _g_free0 (self->action), _tmp0_);
	status_icon_update_progress (self);
}


static void status_icon_note_progress (StatusIcon* self, DejaDupOperation* op, double progress) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (op != NULL);
	self->progress = progress;
	status_icon_update_progress (self);
}


static void status_icon_real_update_progress (StatusIcon* self) {
	g_return_if_fail (self != NULL);
}


void status_icon_update_progress (StatusIcon* self) {
	STATUS_ICON_GET_CLASS (self)->update_progress (self);
}


void status_icon_later (StatusIcon* self) {
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "hide-all");
	deja_dup_operation_stop (self->priv->_op);
}


void status_icon_skip (StatusIcon* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "hide-all");
	{
		deja_dup_update_last_run_timestamp (&_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch7_g_error;
		}
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("StatusIcon.vala:113: %s\n", e->message);
			_g_error_free0 (e);
		}
	}
	__finally7:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	deja_dup_operation_cancel (self->priv->_op);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _lambda2_ (GtkMenuItem* i, StatusIcon* self) {
	g_return_if_fail (i != NULL);
	g_signal_emit_by_name (self, "show-window");
}


static void __lambda2__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	_lambda2_ (_sender, self);
}


static void _lambda3_ (GtkMenuItem* i, StatusIcon* self) {
	g_return_if_fail (i != NULL);
	status_icon_later (self);
}


static void __lambda3__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	_lambda3_ (_sender, self);
}


static void _lambda4_ (GtkMenuItem* i, StatusIcon* self) {
	g_return_if_fail (i != NULL);
	status_icon_skip (self);
}


static void __lambda4__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	_lambda4_ (_sender, self);
}


GtkMenu* status_icon_ensure_menu (StatusIcon* self) {
	GtkMenu* result = NULL;
	GtkMenu* _tmp0_;
	GtkImageMenuItem* imageitem;
	GtkImageMenuItem* _tmp1_;
	GtkImage* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	if (self->menu != NULL) {
		result = _g_object_ref0 (self->menu);
		return result;
	}
	self->menu = (_tmp0_ = g_object_ref_sink ((GtkMenu*) gtk_menu_new ()), _g_object_unref0 (self->menu), _tmp0_);
	imageitem = NULL;
	imageitem = (_tmp1_ = g_object_ref_sink ((GtkImageMenuItem*) gtk_image_menu_item_new_with_mnemonic (_ ("Déjà Du_p"))), _g_object_unref0 (imageitem), _tmp1_);
	gtk_image_menu_item_set_image (imageitem, (GtkWidget*) (_tmp2_ = g_object_ref_sink ((GtkImage*) gtk_image_new_from_icon_name ("deja-dup-symbolic", GTK_ICON_SIZE_MENU))));
	_g_object_unref0 (_tmp2_);
	gtk_image_menu_item_set_always_show_image (imageitem, TRUE);
	g_signal_connect_object ((GtkMenuItem*) imageitem, "activate", (GCallback) __lambda2__gtk_menu_item_activate, self, 0);
	gtk_menu_shell_append ((GtkMenuShell*) self->menu, (GtkWidget*) ((GtkMenuItem*) imageitem));
	if (deja_dup_operation_get_mode (self->priv->_op) == DEJA_DUP_OPERATION_MODE_BACKUP) {
		GtkMenuItem* item;
		GtkSeparatorMenuItem* _tmp3_;
		GtkMenuItem* _tmp4_;
		item = NULL;
		gtk_menu_shell_append ((GtkMenuShell*) self->menu, (GtkWidget*) ((GtkMenuItem*) (_tmp3_ = g_object_ref_sink ((GtkSeparatorMenuItem*) gtk_separator_menu_item_new ()))));
		_g_object_unref0 (_tmp3_);
		item = (_tmp4_ = g_object_ref_sink ((GtkMenuItem*) gtk_menu_item_new_with_mnemonic (self->later_label)), _g_object_unref0 (item), _tmp4_);
		g_signal_connect_object (item, "activate", (GCallback) __lambda3__gtk_menu_item_activate, self, 0);
		gtk_menu_shell_append ((GtkMenuShell*) self->menu, (GtkWidget*) item);
		if (self->priv->_automatic) {
			GtkMenuItem* _tmp5_;
			item = (_tmp5_ = g_object_ref_sink ((GtkMenuItem*) gtk_menu_item_new_with_mnemonic (self->skip_label)), _g_object_unref0 (item), _tmp5_);
			g_signal_connect_object (item, "activate", (GCallback) __lambda4__gtk_menu_item_activate, self, 0);
			gtk_menu_shell_append ((GtkMenuShell*) self->menu, (GtkWidget*) item);
		}
		_g_object_unref0 (item);
	}
	status_icon_update_progress (self);
	gtk_widget_show_all ((GtkWidget*) self->menu);
	result = _g_object_ref0 (self->menu);
	_g_object_unref0 (imageitem);
	return result;
}


StatusIcon* status_icon_construct (GType object_type) {
	StatusIcon * self;
	self = (StatusIcon*) g_object_new (object_type, NULL);
	return self;
}


GtkWindow* status_icon_get_window (StatusIcon* self) {
	GtkWindow* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_window;
	return result;
}


static void status_icon_set_window (StatusIcon* self, GtkWindow* value) {
	GtkWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_window = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_window), _tmp0_);
	g_object_notify ((GObject *) self, "window");
}


DejaDupOperation* status_icon_get_op (StatusIcon* self) {
	DejaDupOperation* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_op;
	return result;
}


static void status_icon_set_op (StatusIcon* self, DejaDupOperation* value) {
	DejaDupOperation* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_op = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_op), _tmp0_);
	g_object_notify ((GObject *) self, "op");
}


gboolean status_icon_get_automatic (StatusIcon* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_automatic;
	return result;
}


static void status_icon_set_automatic (StatusIcon* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_automatic = value;
	g_object_notify ((GObject *) self, "automatic");
}


static void _status_icon_set_action_desc_deja_dup_operation_action_desc_changed (DejaDupOperation* _sender, const char* action, gpointer self) {
	status_icon_set_action_desc (self, _sender, action);
}


static void _status_icon_note_progress_deja_dup_operation_progress (DejaDupOperation* _sender, double percent, gpointer self) {
	status_icon_note_progress (self, _sender, percent);
}


static GObject * status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	StatusIcon * self;
	parent_class = G_OBJECT_CLASS (status_icon_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = STATUS_ICON (obj);
	{
		DejaDupDuplicityInfo* _tmp0_;
		gboolean _tmp1_;
		char* _tmp5_;
		if ((_tmp1_ = deja_dup_duplicity_info_get_can_resume (_tmp0_ = deja_dup_duplicity_info_get_default ()), _g_object_unref0 (_tmp0_), _tmp1_)) {
			char* _tmp2_;
			self->later_label = (_tmp2_ = g_strdup (_ ("_Resume Later")), _g_free0 (self->later_label), _tmp2_);
		} else {
			if (self->priv->_automatic) {
				char* _tmp3_;
				self->later_label = (_tmp3_ = g_strdup (_ ("_Delay Backup")), _g_free0 (self->later_label), _tmp3_);
			} else {
				char* _tmp4_;
				self->later_label = (_tmp4_ = g_strdup (_ ("_Cancel Backup")), _g_free0 (self->later_label), _tmp4_);
			}
		}
		self->skip_label = (_tmp5_ = g_strdup (_ ("_Skip Backup")), _g_free0 (self->skip_label), _tmp5_);
		g_signal_connect_object (self->priv->_op, "action-desc-changed", (GCallback) _status_icon_set_action_desc_deja_dup_operation_action_desc_changed, self, 0);
		g_signal_connect_object (self->priv->_op, "progress", (GCallback) _status_icon_note_progress_deja_dup_operation_progress, self, 0);
	}
	return obj;
}


static void status_icon_class_init (StatusIconClass * klass) {
	status_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (StatusIconPrivate));
	STATUS_ICON_CLASS (klass)->update_progress = status_icon_real_update_progress;
	G_OBJECT_CLASS (klass)->get_property = status_icon_get_property;
	G_OBJECT_CLASS (klass)->set_property = status_icon_set_property;
	G_OBJECT_CLASS (klass)->constructor = status_icon_constructor;
	G_OBJECT_CLASS (klass)->finalize = status_icon_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), STATUS_ICON_WINDOW, g_param_spec_object ("window", "window", "window", GTK_TYPE_WINDOW, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), STATUS_ICON_OP, g_param_spec_object ("op", "op", "op", DEJA_DUP_TYPE_OPERATION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), STATUS_ICON_AUTOMATIC, g_param_spec_boolean ("automatic", "automatic", "automatic", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_signal_new ("show_window", TYPE_STATUS_ICON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("hide_all", TYPE_STATUS_ICON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void status_icon_instance_init (StatusIcon * self) {
	self->priv = STATUS_ICON_GET_PRIVATE (self);
	self->priv->_automatic = FALSE;
	self->is_valid = TRUE;
}


static void status_icon_finalize (GObject* obj) {
	StatusIcon * self;
	self = STATUS_ICON (obj);
	_g_object_unref0 (self->priv->_window);
	_g_object_unref0 (self->priv->_op);
	_g_free0 (self->action);
	_g_free0 (self->later_label);
	_g_free0 (self->skip_label);
	_g_object_unref0 (self->menu);
	G_OBJECT_CLASS (status_icon_parent_class)->finalize (obj);
}


/**
 * There are three modes for 'shell' integration:
 * 1) GNOME Shell
 * 2) Indicator
 * 3) Legacy
 * 
 * GNOME Shell:
 * No status icon at all.
 * Actions on persistent notifications.
 * Detected by 'persistent' capability of notification server.
 * 
 * Indicator:
 * Register as an application indicator, which falls back to standard GTK+ status icon.
 * No notifications.
 * Detected by presence of application indicator host (usually on Ubuntu).
 * 
 * Legacy:
 * Standard GTK+ status icon.
 * No notifications.
 */
GType status_icon_get_type (void) {
	static volatile gsize status_icon_type_id__volatile = 0;
	if (g_once_init_enter (&status_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StatusIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) status_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StatusIcon), 0, (GInstanceInitFunc) status_icon_instance_init, NULL };
		GType status_icon_type_id;
		status_icon_type_id = g_type_register_static (G_TYPE_OBJECT, "StatusIcon", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&status_icon_type_id__volatile, status_icon_type_id);
	}
	return status_icon_type_id__volatile;
}


static void status_icon_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	StatusIcon * self;
	self = STATUS_ICON (object);
	switch (property_id) {
		case STATUS_ICON_WINDOW:
		g_value_set_object (value, status_icon_get_window (self));
		break;
		case STATUS_ICON_OP:
		g_value_set_object (value, status_icon_get_op (self));
		break;
		case STATUS_ICON_AUTOMATIC:
		g_value_set_boolean (value, status_icon_get_automatic (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void status_icon_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	StatusIcon * self;
	self = STATUS_ICON (object);
	switch (property_id) {
		case STATUS_ICON_WINDOW:
		status_icon_set_window (self, g_value_get_object (value));
		break;
		case STATUS_ICON_OP:
		status_icon_set_op (self, g_value_get_object (value));
		break;
		case STATUS_ICON_AUTOMATIC:
		status_icon_set_automatic (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


IndicatorStatusIcon* indicator_status_icon_construct (GType object_type, GtkWindow* window, DejaDupOperation* op, gboolean automatic) {
	IndicatorStatusIcon * self;
	g_return_val_if_fail (window != NULL, NULL);
	g_return_val_if_fail (op != NULL, NULL);
	self = (IndicatorStatusIcon*) g_object_new (object_type, "window", window, "op", op, "automatic", automatic, NULL);
	return self;
}


IndicatorStatusIcon* indicator_status_icon_new (GtkWindow* window, DejaDupOperation* op, gboolean automatic) {
	return indicator_status_icon_construct (TYPE_INDICATOR_STATUS_ICON, window, op, automatic);
}


static GObject * indicator_status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	IndicatorStatusIcon * self;
	parent_class = G_OBJECT_CLASS (indicator_status_icon_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = INDICATOR_STATUS_ICON (obj);
	{
		GtkMenu* _tmp0_;
		GObject* _tmp1_;
		self->priv->indicator = (_tmp1_ = hacks_status_icon_make_app_indicator (_tmp0_ = status_icon_ensure_menu ((StatusIcon*) self)), _g_object_unref0 (self->priv->indicator), _tmp1_);
		_g_object_unref0 (_tmp0_);
		((StatusIcon*) self)->is_valid = self->priv->indicator != NULL;
	}
	return obj;
}


static void indicator_status_icon_class_init (IndicatorStatusIconClass * klass) {
	indicator_status_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (IndicatorStatusIconPrivate));
	G_OBJECT_CLASS (klass)->constructor = indicator_status_icon_constructor;
	G_OBJECT_CLASS (klass)->finalize = indicator_status_icon_finalize;
}


static void indicator_status_icon_instance_init (IndicatorStatusIcon * self) {
	self->priv = INDICATOR_STATUS_ICON_GET_PRIVATE (self);
}


static void indicator_status_icon_finalize (GObject* obj) {
	IndicatorStatusIcon * self;
	self = INDICATOR_STATUS_ICON (obj);
	{
		if (self->priv->indicator != NULL) {
			hacks_status_icon_close_app_indicator (self->priv->indicator);
		}
	}
	_g_object_unref0 (self->priv->indicator);
	G_OBJECT_CLASS (indicator_status_icon_parent_class)->finalize (obj);
}


GType indicator_status_icon_get_type (void) {
	static volatile gsize indicator_status_icon_type_id__volatile = 0;
	if (g_once_init_enter (&indicator_status_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IndicatorStatusIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) indicator_status_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IndicatorStatusIcon), 0, (GInstanceInitFunc) indicator_status_icon_instance_init, NULL };
		GType indicator_status_icon_type_id;
		indicator_status_icon_type_id = g_type_register_static (TYPE_STATUS_ICON, "IndicatorStatusIcon", &g_define_type_info, 0);
		g_once_init_leave (&indicator_status_icon_type_id__volatile, indicator_status_icon_type_id);
	}
	return indicator_status_icon_type_id__volatile;
}


ShellStatusIcon* shell_status_icon_construct (GType object_type, GtkWindow* window, DejaDupOperation* op, gboolean automatic) {
	ShellStatusIcon * self;
	g_return_val_if_fail (window != NULL, NULL);
	g_return_val_if_fail (op != NULL, NULL);
	self = (ShellStatusIcon*) g_object_new (object_type, "window", window, "op", op, "automatic", automatic, NULL);
	return self;
}


ShellStatusIcon* shell_status_icon_new (GtkWindow* window, DejaDupOperation* op, gboolean automatic) {
	return shell_status_icon_construct (TYPE_SHELL_STATUS_ICON, window, op, automatic);
}


static void _lambda0_ (ShellStatusIcon* self) {
	status_icon_later ((StatusIcon*) self);
}


static void __lambda0__notify_action_callback (NotifyNotification* notification, const char* action, gpointer self) {
	_lambda0_ (self);
}


static void _lambda1_ (ShellStatusIcon* self) {
	status_icon_skip ((StatusIcon*) self);
}


static void __lambda1__notify_action_callback (NotifyNotification* notification, const char* action, gpointer self) {
	_lambda1_ (self);
}


static GObject * shell_status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ShellStatusIcon * self;
	GError * _inner_error_;
	parent_class = G_OBJECT_CLASS (shell_status_icon_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = SHELL_STATUS_ICON (obj);
	_inner_error_ = NULL;
	{
		GList* caps;
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		caps = notify_get_server_caps ();
		{
			GList* cap_collection;
			GList* cap_it;
			cap_collection = caps;
			for (cap_it = cap_collection; cap_it != NULL; cap_it = cap_it->next) {
				char* cap;
				cap = g_strdup ((const char*) cap_it->data);
				{
					if (_vala_strcmp0 (cap, "persistence") == 0) {
						self->priv->persistence = TRUE;
					} else {
						if (_vala_strcmp0 (cap, "actions") == 0) {
							self->priv->actions = TRUE;
						}
					}
					_g_free0 (cap);
				}
			}
		}
		if (self->priv->persistence) {
			_tmp0_ = self->priv->actions;
		} else {
			_tmp0_ = FALSE;
		}
		((StatusIcon*) self)->is_valid = _tmp0_;
		if (((StatusIcon*) self)->is_valid) {
			_tmp2_ = status_icon_get_automatic ((StatusIcon*) self);
		} else {
			_tmp2_ = FALSE;
		}
		if (_tmp2_) {
			_tmp1_ = deja_dup_operation_get_mode (status_icon_get_op ((StatusIcon*) self)) == DEJA_DUP_OPERATION_MODE_BACKUP;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			NotifyNotification* note;
			notify_init (g_get_application_name ());
			note = notify_notification_new (_ ("Starting scheduled backup"), NULL, "deja-dup-backup", NULL);
			notify_notification_add_action (note, "later", ((StatusIcon*) self)->later_label, __lambda0__notify_action_callback, g_object_ref (self), g_object_unref);
			notify_notification_add_action (note, "skip", ((StatusIcon*) self)->skip_label, __lambda1__notify_action_callback, g_object_ref (self), g_object_unref);
			{
				notify_notification_show (note, &_inner_error_);
				if (_inner_error_ != NULL) {
					goto __catch8_g_error;
				}
			}
			goto __finally8;
			__catch8_g_error:
			{
				GError * e;
				e = _inner_error_;
				_inner_error_ = NULL;
				{
					g_warning ("StatusIcon.vala:207: %s\n", e->message);
					_g_error_free0 (e);
				}
			}
			__finally8:
			if (_inner_error_ != NULL) {
				_g_object_unref0 (note);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
			}
			deja_dup_operation_set_use_progress (status_icon_get_op ((StatusIcon*) self), FALSE);
			_g_object_unref0 (note);
		}
	}
	return obj;
}


static void shell_status_icon_class_init (ShellStatusIconClass * klass) {
	shell_status_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ShellStatusIconPrivate));
	G_OBJECT_CLASS (klass)->constructor = shell_status_icon_constructor;
	G_OBJECT_CLASS (klass)->finalize = shell_status_icon_finalize;
}


static void shell_status_icon_instance_init (ShellStatusIcon * self) {
	self->priv = SHELL_STATUS_ICON_GET_PRIVATE (self);
	self->priv->persistence = FALSE;
	self->priv->actions = FALSE;
}


static void shell_status_icon_finalize (GObject* obj) {
	ShellStatusIcon * self;
	self = SHELL_STATUS_ICON (obj);
	G_OBJECT_CLASS (shell_status_icon_parent_class)->finalize (obj);
}


GType shell_status_icon_get_type (void) {
	static volatile gsize shell_status_icon_type_id__volatile = 0;
	if (g_once_init_enter (&shell_status_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ShellStatusIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) shell_status_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ShellStatusIcon), 0, (GInstanceInitFunc) shell_status_icon_instance_init, NULL };
		GType shell_status_icon_type_id;
		shell_status_icon_type_id = g_type_register_static (TYPE_STATUS_ICON, "ShellStatusIcon", &g_define_type_info, 0);
		g_once_init_leave (&shell_status_icon_type_id__volatile, shell_status_icon_type_id);
	}
	return shell_status_icon_type_id__volatile;
}


LegacyStatusIcon* legacy_status_icon_construct (GType object_type, GtkWindow* window, DejaDupOperation* op, gboolean automatic) {
	LegacyStatusIcon * self;
	g_return_val_if_fail (window != NULL, NULL);
	g_return_val_if_fail (op != NULL, NULL);
	self = (LegacyStatusIcon*) g_object_new (object_type, "window", window, "op", op, "automatic", automatic, NULL);
	return self;
}


LegacyStatusIcon* legacy_status_icon_new (GtkWindow* window, DejaDupOperation* op, gboolean automatic) {
	return legacy_status_icon_construct (TYPE_LEGACY_STATUS_ICON, window, op, automatic);
}


static void legacy_status_icon_real_update_progress (StatusIcon* base) {
	LegacyStatusIcon * self;
	char* tooltip;
	self = (LegacyStatusIcon*) base;
	tooltip = g_strdup ("");
	if (((StatusIcon*) self)->action != NULL) {
		char* _tmp0_;
		tooltip = (_tmp0_ = g_strdup (((StatusIcon*) self)->action), _g_free0 (tooltip), _tmp0_);
	}
	if (((StatusIcon*) self)->progress > 0) {
		char* _tmp1_;
		char* _tmp2_;
		char* _tmp3_;
		tooltip = (_tmp3_ = g_strconcat (_tmp1_ = g_strconcat (tooltip, "\n", NULL), _tmp2_ = g_strdup_printf (_ ("%.1f%% complete"), ((StatusIcon*) self)->progress * 100), NULL), _g_free0 (tooltip), _tmp3_);
		_g_free0 (_tmp2_);
		_g_free0 (_tmp1_);
	}
	gtk_status_icon_set_tooltip_text (self->priv->icon, tooltip);
	_g_free0 (tooltip);
}


static void _gtk_status_icon_position_menu_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self) {
	gtk_status_icon_position_menu (menu, x, y, push_in, self);
}


static void legacy_status_icon_show_menu (LegacyStatusIcon* self, GtkStatusIcon* status_icon, guint button, guint activate_time) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (status_icon != NULL);
	gtk_menu_popup (((StatusIcon*) self)->menu, NULL, NULL, _gtk_status_icon_position_menu_gtk_menu_position_func, status_icon, button, (guint32) activate_time);
}


static void _legacy_status_icon_show_menu_gtk_status_icon_popup_menu (GtkStatusIcon* _sender, guint button, guint activate_time, gpointer self) {
	legacy_status_icon_show_menu (self, _sender, button, activate_time);
}


static void _lambda5_ (GtkStatusIcon* s, LegacyStatusIcon* self) {
	g_return_if_fail (s != NULL);
	legacy_status_icon_show_menu (self, s, (guint) 0, (guint) gtk_get_current_event_time ());
}


static void __lambda5__gtk_status_icon_activate (GtkStatusIcon* _sender, gpointer self) {
	_lambda5_ (_sender, self);
}


static GObject * legacy_status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	LegacyStatusIcon * self;
	parent_class = G_OBJECT_CLASS (legacy_status_icon_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = LEGACY_STATUS_ICON (obj);
	{
		GtkStatusIcon* _tmp0_;
		GtkMenu* _tmp1_;
		self->priv->icon = (_tmp0_ = gtk_status_icon_new (), _g_object_unref0 (self->priv->icon), _tmp0_);
		g_object_set ((GObject*) self->priv->icon, "icon-name", "deja-dup-symbolic", "title", g_get_application_name (), NULL);
		_tmp1_ = status_icon_ensure_menu ((StatusIcon*) self);
		_g_object_unref0 (_tmp1_);
		g_signal_connect_object (self->priv->icon, "popup-menu", (GCallback) _legacy_status_icon_show_menu_gtk_status_icon_popup_menu, self, 0);
		g_signal_connect_object (self->priv->icon, "activate", (GCallback) __lambda5__gtk_status_icon_activate, self, 0);
	}
	return obj;
}


static void legacy_status_icon_class_init (LegacyStatusIconClass * klass) {
	legacy_status_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (LegacyStatusIconPrivate));
	STATUS_ICON_CLASS (klass)->update_progress = legacy_status_icon_real_update_progress;
	G_OBJECT_CLASS (klass)->constructor = legacy_status_icon_constructor;
	G_OBJECT_CLASS (klass)->finalize = legacy_status_icon_finalize;
}


static void legacy_status_icon_instance_init (LegacyStatusIcon * self) {
	self->priv = LEGACY_STATUS_ICON_GET_PRIVATE (self);
}


static void legacy_status_icon_finalize (GObject* obj) {
	LegacyStatusIcon * self;
	self = LEGACY_STATUS_ICON (obj);
	_g_object_unref0 (self->priv->icon);
	G_OBJECT_CLASS (legacy_status_icon_parent_class)->finalize (obj);
}


GType legacy_status_icon_get_type (void) {
	static volatile gsize legacy_status_icon_type_id__volatile = 0;
	if (g_once_init_enter (&legacy_status_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LegacyStatusIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) legacy_status_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LegacyStatusIcon), 0, (GInstanceInitFunc) legacy_status_icon_instance_init, NULL };
		GType legacy_status_icon_type_id;
		legacy_status_icon_type_id = g_type_register_static (TYPE_STATUS_ICON, "LegacyStatusIcon", &g_define_type_info, 0);
		g_once_init_leave (&legacy_status_icon_type_id__volatile, legacy_status_icon_type_id);
	}
	return legacy_status_icon_type_id__volatile;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




